package WebFlow.hashtable;

import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.util.*;
import java.io.*; 

public class SaveContextImpl extends WebFlow.BeanContextChildSupport 
                         implements SaveContextOperations {

  String msg_;
  org.omg.CORBA.Object peer;
  boolean debug = true;

  public SaveContextImpl(org.omg.CORBA.Object peer, String msg)
       throws WebFlow.NullPointerException{

  super(peer);
  this.peer = peer;
  String msg_ = msg;
 }

  public void test(){
   System.out.println("SaveContext is up");
  } 

  public void saveContextData(WebFlowContext context){
      ContextData cd = findContextData(context);
      System.out.println("get Keys"); 
      String[] Keys = cd.getKeys();
      int n = Keys.length;
      System.out.println("number of Keys: "+n);
      String curDir=cd.getParam("Directory")+File.separator+"ContextData.txt";
      System.out.println(curDir);
      if(n>0) { 

      try {
           FileWriter fw = new FileWriter(curDir);       
           for(int i=0;i<n;i++){
             fw.write(Keys[i]+" "+cd.getParam(Keys[i])+"\n");
	   }
           fw.flush();
           fw.close();
      }
      catch (Exception e) {System.out.println(e);}  
      }
      else {
       System.out.println("oops, nothing to save!");
      }
  }


    public void restoreUserContextData(WebFlowContext uc, String rootDir){
	//restoreUserContextData is different than restore other contexts
        //beacuse the user context already exists when this method is
        //invoked, and its name is known. For other contexts, you have to
        //find out the number and names of children contexts from their
        //parent, create these contexts and only then read the context data
        //WARNING: never used


	File root = new File(rootDir);
        if(!(root.exists())) {
           System.err.println("the root directory does not exist!!!");
           System.err.println(rootDir);
	}
	else {
	    readContextData(uc,rootDir);
	}

    }


   public void readContextData(WebFlowContext context, String curDir) {
    ContextData cd = findContextData(context);
    try { 
     FileReader fr = new FileReader(curDir+File.separator+"ContextData.txt");
     BufferedReader in = new BufferedReader(fr);
     String nextLine="";
     StringTokenizer st;
     while((nextLine=in.readLine()) != null) {  
        st=new StringTokenizer(nextLine);
        String Name=st.nextToken();
        String Value=st.nextToken();
        System.out.println(Name+"="+Value);
        cd.setParam(Name,Value); 
     }
   } catch (Exception e) {System.out.println(e);}  
  }



  public void restoreContextData(WebFlowContext context, String DDir){
     ContextData cd = findContextData(context);
     String curDir=DDir+"USER";
     System.out.println("restore: "+curDir); 

     // find location of the saved file
     String ID = context.getObjectID();  
     System.out.println("ID="+ID);


     StringTokenizer st1 = new StringTokenizer(ID,File.separator);
     String dummy = st1.nextToken(); //master server id, ignore it 
     System.out.println("master server = "+dummy);
     System.out.println(st1.countTokens());
     while(st1.hasMoreTokens()) {
       // drop suffix, if any (but not for the user which ends with ".")
       String s = st1.nextToken();
       if(!s.endsWith(".")) {
          int idx = s.indexOf(".");
          if(idx>-1) s = s.substring(0,idx);
       }
       curDir += File.separator +s;
     }
     System.out.println("Directory is "+curDir); 
     
     try { 
     FileReader fr = new FileReader(curDir+File.separator+"ContextData.txt");
     BufferedReader in = new BufferedReader(fr);
     String nextLine="";
     StringTokenizer st;
     while((nextLine=in.readLine()) != null) {  
        st=new StringTokenizer(nextLine);
        String Name=st.nextToken();
        String Value=st.nextToken();
        System.out.println(Name+"="+Value);
        cd.setParam(Name,Value); 
     }
     } catch (Exception e) {System.out.println(e);}  
  }


  public void setContextData(WebFlowContext c, String name, String value){
         ContextData cd = findContextData(c);
         cd.setParam(name,value);
     }    

  public String getContextData(WebFlowContext c, String name) {
          ContextData cd = findContextData(c);
          String value = cd.getParam(name); 
          return value;
     }

  public ContextData findContextData(WebFlowContext wfc) {
          ContextData wfcContextData=null;

          String ContextDataName = wfc.getObjectID()+"/ContextData";
          org.omg.CORBA.Object o = wfc.getKeyedChild(ContextDataName);
          if(o != null) {
          wfcContextData = ContextDataHelper.narrow(o); 
	  } else {System.out.println("Context data not found!");}

	  if(wfcContextData==null) {
            System.out.println("Context data not found!");
	  }
        return wfcContextData;
       }
   
    public void serializeArray(String[] a, String filename) {

      try {
        FileOutputStream fileOut = new FileOutputStream(filename);
        ObjectOutputStream out = new ObjectOutputStream(fileOut);
        out.writeObject(a);
      }
      catch (Exception e) {System.out.println(e+" while serializeArray");}
    }

    public String[] deserializeArray(String filename) {
        String[] a = null;
	try {
           FileInputStream fileIn = new FileInputStream(filename);
           ObjectInputStream in = new ObjectInputStream(fileIn);
           a = (String[])in.readObject();
	}
        catch (Exception e) {
             System.out.println(e);
             a=new String[1];
             a[0]="none";
	}
        return a; 
    } 
 
}







